#include <stdio.h>
#include <ctype.h>
#include <stdarg.h>
#include "ptt.h"

/* Avoid ugly tests for errors in the main code */
#include <stdio.h>
extern void *malloc();

char *progname;

void
fatal (char *s, ...) {
    va_list p;
    fprintf (stderr, "%s: ", progname);
    va_start(p, s);
    vfprintf (stderr, s, p);
    va_end(p);
    exit (1);
}


void *
myalloc(unsigned int n) {
    void *p = malloc(n);
    if(!p)
	fatal("Out of memory\n");
    return p;
}

FILE *
myopen(char *s) {
    FILE *f;

    f = fopen(s, "r");
    if(!f) {
	perror(s);
	fatal("Could not open %s for reading\n", s);
    }
    return f;
}

void
myseek(FILE *f, long offset, int whence) {
    if(fseek(f,offset,whence) != 0) {
	perror("seek failed");
	exit(1);
    }
}

long
mysize(FILE *f) {		/* or: use stat */
    long sz;

    myseek(f, 0, SEEK_END);
    sz = ftell(f);
    return sz;
}

void
trailck(uchar *s, int req, int lth, char *name) {
    int i,j;

    for(i=0; i<lth; i++)
      if(s[i] == 0)
	break;
    if (i < req) {
	if(i)
	  fprintf(stderr, "** short field %s: %s has length %d < %d\n", name, s, i, req);
	else
	  fprintf(stderr, "** absent field %s\n", name);
    }
    for( ; i<lth; i++)
      if(s[i])
	break;
    if (i < lth) {
	fprintf(stderr, "** junk in field %s:", name);
	for(j=0; j<lth; j++)
	  fprintf(stderr, " 0%o", s[j]);
	fprintf(stderr, "\n");
    }
}

void
grow_string(string *s, int incr) {
    s->alloclth += incr;
    s->p = (char *) realloc(s->p, s->alloclth);
    if(!s->p)
	fatal("Realloc failed - out of memory\n");
}

uchar *
strtolower(uchar *ss) {
    uchar *s = ss;
    while(*s) {
	*s = tolower(*s);
	s++;
    }
    return ss;
}
